<template>
  <v-card
    class="mx-auto"
    max-width="344"
    justify="center" align="center"
  >
    <h1>Registreren</h1>
    <div class="switcher" >
      <v-switch
        v-model="switch1"
        justify="center"
      ></v-switch>
    </div>

  <div v-if="switch1" class="form">
    <h2>Klant</h2>

    <v-text-field
      label="Gebruikersnaam"
      :rules="rules"
      hide-details="auto"
      v-model="clientUsername"
    ></v-text-field>
    <v-text-field
      label="email"
      :rules="rules"
      hide-details="auto"
      v-model="clientEmail"
    ></v-text-field>
    <v-text-field
      label="adres"
      :rules="rules"
      hide-details="auto"
      v-model="clientAddress"
    ></v-text-field>
    <v-text-field type="password" :rules="rules" label="Wachtwoord" v-model="clientPassword"></v-text-field>
    <v-btn depressed
    @click="registerUser">
      Registreer
    </v-btn>
  </div>

    <div v-if="!switch1" class="form">
      <h2>Verkoper</h2>

      <v-text-field
        label="Gebruikersnaam"
        :rules="rules"
        hide-details="auto"
        v-model="sellerUsername"
      ></v-text-field>
      <v-text-field
        label="email"
        :rules="rules"
        hide-details="auto"
        v-model="sellerEmail"
      ></v-text-field>
      <v-text-field
        label="adres"
        :rules="rules"
        hide-details="auto"
        v-model="sellerAddress"
      ></v-text-field>
      <v-text-field
        label="Gsm nummer"
        :rules="numberRules"
        hide-details="auto"
        v-model="sellerPhonenumber"
      ></v-text-field>
      <v-text-field type="password" :rules="rules" label="Wachtwoord" v-model="sellerPassword"></v-text-field>
      <v-btn depressed
      @click="registerSeller">
        Registreer
      </v-btn>
    </div>
  </v-card>
</template>

<script>
import {registerUser, registerSeller} from '~/clients/authClient';
import { auth } from '~/firebase';

export default {
  name: 'register',
  data() {
    return {
      switch1: true,
      rules: [
        value => !!value || 'Required.',
        value => (value && value.length >= 8) || 'Min 8 characters.',
      ],
      numberRules: [
        v => v.length > 0 || "Required.",
        v =>
          Number.isInteger(Number(v)) || "Dit is geen telefoon nummer.",
        v => v > 0 || "Dit is geen telefoon nummer."
      ],
      clientEmail: '',
      clientPassword: '',
      clientUsername: '',
      clientAddress: '',
      sellerEmail: '',
      sellerPassword: '',
      sellerUsername: '',
      sellerAddress: '',
      sellerPhonenumber: '',
      error: ''
    }
  },
  methods: {
    async registerUser() {
      await registerUser(this.clientEmail, this.clientPassword, this.clientUsername, this.clientAddress).then(
        this.$router.push("/")
      ).catch(
        this.error = 'Er ging iets mis.'
      )
    },
    async registerSeller() {
      await registerSeller(this.sellerEmail, this.sellerPassword, this.sellerUsername, this.sellerAddress, this.sellerPhonenumber).then(
        this.$router.push("/")
      ).catch(
        this.error = 'Er ging iets mis.'
      )
    },
  },
  head() {
    return {
      title: "Register",
      meta: [
        { hid: 'description', name: 'description', content: 'Registereer je nu voor TopicShop!' },
        { hid: 'keywords', name: 'keywords', content: '3D, 3D printer, webshop, 3D component, PLA-filament, kopen, verkopen, registreren, TopicShop'},
      ]
    }
  }
};
</script>

<style scoped>
.switcher {
  display: flex;
  justify-content: center;
}

.form {
  padding: 1rem;
}
</style>
